From: Eduardo Otubo <otubo@redhat.com>
To: linux-kernel@vger.kernel.org
Cc: "K . Y . Srinivasan" <kys@microsoft.com>,
Haiyang Zhang <haiyangz@microsoft.com>,
Stephen Hemminger <sthemmin@microsoft.com>,
devel@linuxdriverproject.org, David Miller <davem@davemloft.net>
Subject: [PATCHv2] hv_set_ifconfig.sh double check before setting ip
Date: Mon, 28 Aug 2017 12:01:21 +0200 [thread overview]
Message-ID: <20170828100121.17321-1-otubo@redhat.com> (raw)
v2: The script is now a little bit safer so it doesn't conflicts with
network daemon trying to set configurations at the same time.
This patch fixes the behavior of the hv_set_ifconfig script when setting
the interface ip. Sometimes the interface has already been configured by
network daemon, in this case hv_set_ifconfig causes "RTNETLINK: file
exists error"; in order to avoid this error this patch makes sure double
checks the interface before trying anything.
Signed-off-by: Eduardo Otubo <otubo@redhat.com>
---
tools/hv/hv_set_ifconfig.sh | 44 ++++++++++++++++++++++++++++++++++++--------
1 file changed, 36 insertions(+), 8 deletions(-)
diff --git a/tools/hv/hv_set_ifconfig.sh b/tools/hv/hv_set_ifconfig.sh
index 735aafd64a3f..3a04b91f61e3 100755
--- a/tools/hv/hv_set_ifconfig.sh
+++ b/tools/hv/hv_set_ifconfig.sh
@@ -46,19 +46,47 @@
# is expected to return the configuration that is set via the SET
# call.
#
+interface=$(echo $1 | awk -F - '{ print $2 }')
+current_ip=$(ip addr show $interface|grep "inet ");
+config_file_ip=$(grep IPADDR $1|cut -d"=" -f2);
+current_ipv6=$(ip addr show $interface|grep "inet6 ");
+config_file_ipv6=$(grep IPV6ADDR $1|cut -d"=" -f2);
+config_file_ipv6_netmask=$(grep IPV6NETMASK $1|cut -d"=" -f2);
+config_file_ipv6=${config_file_ipv6}/${config_file_ipv6_netmask};
-echo "IPV6INIT=yes" >> $1
-echo "NM_CONTROLLED=no" >> $1
-echo "PEERDNS=yes" >> $1
-echo "ONBOOT=yes" >> $1
+network_service_state=$(/bin/systemctl is-active network);
+while [[ ${network_service_state} == "activating" \
+ || ${network_service_state} == "deactivating" ]]; do
+ # Network script is still working. let's wait a bit.
+ # The default timeout for systemd is 90s.
+ sleep 30s;
+ ((i++));
+ network_service_state=$(/bin/systemctl is-active network);
-cp $1 /etc/sysconfig/network-scripts/
+ # If network service doens't come up or down in 90s we log the
+ # error and give up.
+ if [[ $i == 3 ]]; then
+ logger "Couldn't set IP address for fail-over interface"\
+ " because network daemon might be busy. Try to"\
+ " if-down $interface && if-up $interface"\
+ " manually later.";
+ exit 1;
+ fi
+done
+# Only set the IP if it's not configured yet.
+if [[ $(test "${current_ip#*$config_file_ip}") == "$config_file_ip" \
+ || $(test "${current_ipv6#*$config_file_ipv6}") == "$current_ipv6" ]]; then
+ echo "IPV6INIT=yes" >> $1
+ echo "NM_CONTROLLED=no" >> $1
+ echo "PEERDNS=yes" >> $1
+ echo "ONBOOT=yes" >> $1
-interface=$(echo $1 | awk -F - '{ print $2 }')
+ cp $1 /etc/sysconfig/network-scripts/
-/sbin/ifdown $interface 2>/dev/null
-/sbin/ifup $interface 2>/dev/null
+ /sbin/ifdown $interface 2>/dev/null
+ /sbin/ifup $interface 2>/dev/null
+fi
--
2.13.5
next reply other threads:[~2017-08-28 10:01 UTC|newest]
Thread overview: 8+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-08-28 10:01 Eduardo Otubo [this message]
2017-08-28 13:47 ` Olaf Hering
2017-08-28 15:16 ` Stephen Hemminger
2017-08-28 15:56 ` Haiyang Zhang
2017-08-28 16:05 ` Eduardo Otubo
2017-08-28 16:48 ` KY Srinivasan
2017-08-31 8:16 ` Eduardo Otubo
2017-08-31 20:21 ` KY Srinivasan
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20170828100121.17321-1-otubo@redhat.com \
--to=otubo@redhat.com \
--cc=davem@davemloft.net \
--cc=devel@linuxdriverproject.org \
--cc=haiyangz@microsoft.com \
--cc=kys@microsoft.com \
--cc=linux-kernel@vger.kernel.org \
--cc=sthemmin@microsoft.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox
all inboxes | Powered by JetHome®